package com.examples.pfsoft.mispozosderiego;

import android.content.Intent;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.widget.Toast;

import com.firebase.ui.auth.AuthUI;
import com.firebase.ui.auth.ResultCodes;
import com.google.firebase.auth.FirebaseAuth;
import com.google.firebase.auth.FirebaseUser;
import com.google.firebase.database.DataSnapshot;
import com.google.firebase.database.DatabaseError;
import com.google.firebase.database.DatabaseReference;
import com.google.firebase.database.ValueEventListener;

import java.util.Arrays;

/**
 * Created by VRaul on 17/02/2017.
 */

public class ActivityLogin extends AppCompatActivity {
    private static final int RC_SIGN_IN = 123;
    private FirebaseAuth auth;

    @Override protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_login);
        auth = ((Aplicacion) getApplicationContext()).getAuth();
        doLogin();
    }

    private void doLogin() {
        FirebaseUser currentUser = auth.getCurrentUser();
        if (currentUser != null) {
            //guardarUsuario(currentUser);
            boolean emailverified = true;

            String name = currentUser.getDisplayName();
            String email = currentUser.getEmail();
            String provider = currentUser.getProviders().get(0);
            SharedPreferences pref = getSharedPreferences(
                    "com.examples.pfsoft.mispozosderiego_internal", MODE_PRIVATE);
            pref.edit().putString("provider", provider).commit();
            pref.edit().putString("name", name).commit();
            if (email != null) {
                pref.edit().putString("email", email).commit();

                if (provider == AuthUI.EMAIL_PROVIDER) {
                    emailverified = currentUser.isEmailVerified();
                }
            }
            Intent i = new Intent(this, ActivityMain.class);
            i.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP
                    | Intent.FLAG_ACTIVITY_NEW_TASK
                    | Intent.FLAG_ACTIVITY_CLEAR_TASK);

            if (!emailverified){
                currentUser.sendEmailVerification();
                Toast.makeText(this, "Se le ha enviado un correo de verificación a la cuenta de correo, no olvide revisarlo.", Toast.LENGTH_LONG).show();
                AuthUI.getInstance().signOut(this);
            } else {
                startActivity(i);
            }
            startActivity(i);
        } else {
            startActivityForResult(AuthUI.getInstance()
                    .createSignInIntentBuilder().setProviders(Arrays.asList(
                            new AuthUI.IdpConfig.Builder(AuthUI.EMAIL_PROVIDER).build(),
                            new AuthUI.IdpConfig.Builder(AuthUI.GOOGLE_PROVIDER).build()))
                    .setIsSmartLockEnabled(false).build(), RC_SIGN_IN);
        }
    }

    @Override public void onActivityResult(int requestCode, int resultCode,
                                           Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        if (requestCode == RC_SIGN_IN) {
            if (resultCode == ResultCodes.OK) {
                doLogin();
                finish();
            }
        }
    }

    /*
    void guardarUsuario(final FirebaseUser user) {
        DatabaseReference usersReference=((Aplicacion) getApplicationContext())
                .getUsersReference();
        final DatabaseReference currentUserReference = usersReference.child(
                user.getUid());
        ValueEventListener userListener = new ValueEventListener() {
            @Override public void onDataChange(DataSnapshot dataSnapshot) {
                if (!dataSnapshot.exists()) {
                    currentUserReference.setValue(new User(
                            user.getDisplayName(), user.getEmail()));
                }
            }
            @Override public void onCancelled(DatabaseError databaseError) {}
        };
        currentUserReference.addListenerForSingleValueEvent(userListener);
    }
    */

}
