package com.examples.pfsoft.mispozosderiego;

import android.content.Intent;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.LinearLayoutManager;
import android.support.v7.widget.RecyclerView;
import android.support.v7.widget.Toolbar;
import android.view.View;

/**
 * Created by VRaul on 04/12/2016 - [Revision @PFSoft 08/2017]
 * Clase que gestiona la Actividad para Mostrar Recycler View con los Pozos para su selección
 * Para posteriormente poder mostrar su información, editar, añadir y/o eliminarlos
 */

public class ActivitySeleccionPozo extends AppCompatActivity {

    private RecyclerView recyclerView;
    //public AdaptadorPozos adaptador; //Utiliza Array
    //public static AdaptadorPozosBD adaptador; //Utiliza BD
    private RecyclerView.LayoutManager layoutManager;
    private Aplicacion app;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_seleccionpozo);

        //Gestíón Toolbar...
        Toolbar toolbar = (Toolbar) findViewById(R.id.toolbar4);
        setSupportActionBar(toolbar);

        app = (Aplicacion) getApplication();

    }

    @Override
    protected void onResume(){
        super.onResume();

        //Codigo para Recycler View
        recyclerView = (RecyclerView) findViewById(R.id.recycler_view);
        recyclerView.setAdapter(app.getAdaptadorpozos());
        layoutManager = new LinearLayoutManager(this);
        recyclerView.setLayoutManager(layoutManager);

        //Escuchador de eventos por selección de un elemento del Recycler View
        app.getAdaptadorpozos().setOnItemClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Intent i = new Intent(ActivitySeleccionPozo.this, ActivityVistaPozo.class);
                i.putExtra("id", (long) recyclerView.getChildAdapterPosition(v));
                //i.putExtra("seleccion", true); //Indica que viene desde Vista Seleccion Pozo
                startActivity(i);
            }
        });

    }



}
