package com.examples.pfsoft.mispozosderiego;

import android.os.Bundle;
import android.support.design.widget.FloatingActionButton;
import android.support.design.widget.Snackbar;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.LinearLayoutManager;
import android.support.v7.widget.RecyclerView;
import android.support.v7.widget.Toolbar;
import android.view.View;
import android.widget.TextView;

import com.google.firebase.database.DatabaseReference;

/**
 * Created by VRaul on 11/12/2016.
 */

public class ActivityVistaAlarmaHist extends AppCompatActivity {
    private long id;
    private InfoPozoRiego pozo;
    private Aplicacion app;
    private RecyclerView recyclerView;
    private RecyclerView.LayoutManager layoutManager;


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_vistaalarmahist);

        app = (Aplicacion) getApplication();

        //Gestíón Toolbar...
        Toolbar toolbar = (Toolbar) findViewById(R.id.toolbar8);
        setSupportActionBar(toolbar);

    }


    @Override
    protected void onResume(){
        super.onResume();
        //Obtener id del Pozo a visualizar...
        Bundle extras = getIntent().getExtras();
        id = extras.getLong("id", -1);
        //Para Firebase --->

        //Funciona por posición en el RecyclerView == posicion ArrayList --> Version obsoleta
        //pozo = app.getPozos().elemento((int) id);

        //Funciona por id_pozo --> Nueva versión
        String keyidpozo= app.getStrKeyIdPozo((int)id); //Obtener Clave String a partir del id_pozo
        pozo = app.getPozos().elementoByKey(keyidpozo);


        //Obtener Nombre pozo y asignarlo a la Vista
        TextView nombre = (TextView) findViewById(R.id.nompozo5);
        nombre.setText(pozo.getNombre());

        //Obtener key idpozo para tener referecia al nodo de alarmass que nos interesa
        String keypozo = app.getStrKeyIdPozo(pozo.getId_pozo());
        DatabaseReference nodopozo = app.getAlarmasReference().child(keypozo);

        //Crear Alamacen y Adaptador (Historico Alarmas) para los datos obtenidos desde firebase a  partir de la referencia
        app.setAlarmas(new AlmacenAlarmaHistFBase(this, nodopozo));
        app.getAlarmas().activaEscuchadorAlarmaHist();
        app.setAdaptadorAlarmas(new AdaptadorAlarmaHist(this, app.getAlarmas()));

        //Codigo para Recycler View
        recyclerView = (RecyclerView) findViewById(R.id.recycler_view4);
        recyclerView.setAdapter(app.getAdaptadorAlarmas());
        layoutManager = new LinearLayoutManager(this);
        recyclerView.setLayoutManager(layoutManager);

    }

}
