package com.examples.pfsoft.mispozosderiego;

import android.content.Intent;
import android.content.res.Resources;
import android.os.Bundle;
import android.support.design.widget.FloatingActionButton;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.Toolbar;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.ImageView;
import android.widget.TextView;

import java.text.DateFormat;
import java.text.DecimalFormat;
import java.util.Date;

/**
 * Created by VRaul on 04/12/2016.
 */

public class ActivityVistaEstadoPozo extends AppCompatActivity {

    private long id;
    private InfoPozoRiego pozo;
    private InfoEstadoPozo estadopozo;
    private Aplicacion app;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_vistaestadopozo);

        app = (Aplicacion) getApplication();

        //Gestíón Toolbar...
        Toolbar toolbar = (Toolbar) findViewById(R.id.toolbar6);
        setSupportActionBar(toolbar);

        //Escuchador de eventos para gestión Botón Flotante...
        FloatingActionButton fab = (FloatingActionButton) findViewById(R.id.fab6);
        fab.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                lanzarVistaPozosSimple(null);
                //Snackbar.make(view, "Replace with your own action", Snackbar.LENGTH_LONG)
                //        .setAction("Action", null).show();
            }
        });
    }


    @Override
    protected void onResume(){
        super.onResume();
        //Obtener id del Pozo a visualizar...
        Bundle extras = getIntent().getExtras();
        id = extras.getLong("id", -1);
        //----> Corregir para Firebase --->
        /*
        //Funciona por posición en el RecyclerView == posicion ArrayList --> Version obsoleta
        pozo = app.getPozos().elemento((int) id);
        estadopozo = app.getEstadopozos().elemento((int) id);
        */
        //Funciona por id_pozo --> Nueva versión
        String keyidpozo= app.getStrKeyIdPozo((int)id); //Obtener Clave String a partir del id_pozo
        pozo = app.getPozos().elementoByKey(keyidpozo);
        estadopozo = app.getEstadopozos().elementoByKey(keyidpozo);

        //Llamada Procedimiento para rellenar VistaPozo con la información del Pozo
        SetVistaEstadoPozo();
    }


    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_vistaestadopozo, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.

        switch (item.getItemId()) {
            case R.id.accion_riegos:
                lanzarRiegosHist(null);
                return true;
            case R.id.accion_alarmas:
                lanzarAlarmasHist(null);
                return true;

            default:
                return super.onOptionsItemSelected(item);
        }
    }

    void SetVistaEstadoPozo (){
        int id;
        Resources res = getResources();

        TextView nombre = (TextView) findViewById(R.id.nompozo2);
        nombre.setText(pozo.getNombre());

        ImageView imgLogoEsGoteo = (ImageView) findViewById(R.id.logo_esgoteo2);
        if (pozo.isEs_goteo()) {
            id = R.mipmap.ic_wet;
        } else {
            id = R.mipmap.ic_waterelement;
        }
        imgLogoEsGoteo.setImageResource(id);

        TextView numsectores = (TextView) findViewById(R.id.numsectores2);
        numsectores.setText(Integer.toString(pozo.getNum_sectores()));

        TextView telefono = (TextView) findViewById(R.id.telefono2);
        telefono.setText(pozo.getTelefono());

        TextView fechasms = (TextView) findViewById(R.id.fechasms);
        //Log.d("===> fechasms ",Long.toString(estadopozo.getFechahora_sms()));
        fechasms.setText(DateFormat.getDateTimeInstance().format(new Date(estadopozo.getFechahora_sms())));

        ImageView imgLogoEstado = (ImageView) findViewById(R.id.logo_estado2);
        imgLogoEstado.setImageResource(estadopozo.getRecursoIconoEstado());

        TextView txtestado = (TextView) findViewById(R.id.estadopozo);
        txtestado.setText(estadopozo.getEnum_estadopozo().getTexto());

        TextView infoalarma = (TextView) findViewById(R.id.tipo_alarma);
        switch(estadopozo.getEnum_estadopozo().getId_estado()) {
            case 30:
            case 31:
            case 32:
                txtestado.setTextColor(res.getColor(R.color.colorAlarma1));
                infoalarma.setVisibility(View.VISIBLE);
                infoalarma.setText(estadopozo.getEnum_infoalarma().getTexto());
                infoalarma.setTextColor(res.getColor(R.color.colorAlarma2));
                break;
            default:
                txtestado.setTextColor(res.getColor(R.color.colorBlanco));
                infoalarma.setVisibility(View.GONE);
                break;
        }

        TextView numprog = (TextView) findViewById(R.id.programa);
        numprog.setText(Integer.toString(estadopozo.getPrograma()));

        TextView sector1 = (TextView) findViewById(R.id.sector1);
        if (estadopozo.esSectorActivo(1)){
            sector1.setVisibility(View.VISIBLE);
            sector1.setTextColor(res.getColor(R.color.colorVerdeOn));
        } else{
            //sector1.setVisibility(View.INVISIBLE);
            sector1.setTextColor(res.getColor(R.color.colorGrisOff));
        }
        TextView sector2 = (TextView) findViewById(R.id.sector2);
        if (estadopozo.esSectorActivo(2)){
            sector2.setVisibility(View.VISIBLE);
            sector2.setTextColor(res.getColor(R.color.colorVerdeOn));
        } else{
            //sector2.setVisibility(View.INVISIBLE);
            sector2.setTextColor(res.getColor(R.color.colorGrisOff));
        }
        TextView sector3 = (TextView) findViewById(R.id.sector3);
        if (estadopozo.esSectorActivo(3)){
            sector3.setVisibility(View.VISIBLE);
            sector3.setTextColor(res.getColor(R.color.colorVerdeOn));
        } else{
            //sector3.setVisibility(View.INVISIBLE);
            sector3.setTextColor(res.getColor(R.color.colorGrisOff));
        }
        TextView sector4 = (TextView) findViewById(R.id.sector4);
        if (estadopozo.esSectorActivo(4)){
            sector4.setVisibility(View.VISIBLE);
            sector4.setTextColor(res.getColor(R.color.colorVerdeOn));
        } else{
            //sector4.setVisibility(View.INVISIBLE);
            sector4.setTextColor(res.getColor(R.color.colorGrisOff));
        }
        TextView sector5 = (TextView) findViewById(R.id.sector5);
        if (estadopozo.esSectorActivo(5)){
            sector5.setVisibility(View.VISIBLE);
            sector5.setTextColor(res.getColor(R.color.colorVerdeOn));
        } else{
            //sector5.setVisibility(View.INVISIBLE);
            sector5.setTextColor(res.getColor(R.color.colorGrisOff));
        }
        TextView sector6 = (TextView) findViewById(R.id.sector6);
        if (estadopozo.esSectorActivo(6)){
            sector6.setVisibility(View.VISIBLE);
            sector6.setTextColor(res.getColor(R.color.colorVerdeOn));
        } else{
            //sector6.setVisibility(View.INVISIBLE);
            sector6.setTextColor(res.getColor(R.color.colorGrisOff));
        }

        TextView fechainicio = (TextView) findViewById(R.id.fechainicio);
        fechainicio.setText(estadopozo.getFecha_inicio());

        TextView horainicio = (TextView) findViewById(R.id.horainicio);
        horainicio.setText(estadopozo.getHora_inicio());

        TextView duracion = (TextView) findViewById(R.id.duracion);
        duracion.setText(estadopozo.conversionDuracion());

        DecimalFormat fmt = new DecimalFormat("0.0");
        TextView caudal = (TextView) findViewById(R.id.caudal);
        caudal.setText(fmt.format(estadopozo.getCaudal()));
        //caudal.setText(Float.toString(estadopozo.getCaudal()));

        TextView potencia = (TextView) findViewById(R.id.potencia);
        potencia.setText(fmt.format(estadopozo.getPot_consumida()));
        //potencia.setText(Float.toString(estadopozo.getPot_consumida()));
    }


    //Abrir Actividad Vista Pozos...
    public void lanzarVistaPozosSimple(View view){
        Intent i = new Intent(ActivityVistaEstadoPozo.this, ActivityVistaPozoSimple.class);
        //i.putExtra("id", id); //Funciona por posicion RecyclerView
        i.putExtra("id", (long) pozo.getId_pozo()); //Funciona por id_pozo
        startActivity(i);
    }


    //Abrir Actividad Vista Riegos Historico...
    public void lanzarRiegosHist(View view){
        Intent i = new Intent(this, ActivityVistaRiegoHist.class);
        //i.putExtra("id", id);//Funciona por posicion RecyclerView
        i.putExtra("id", (long) pozo.getId_pozo()); //Funciona por id_pozo
        startActivity(i);
    }

    //Abrir Actividad Vista Alarmas Historico...
    public void lanzarAlarmasHist(View view){
        Intent i = new Intent(this, ActivityVistaAlarmaHist.class);
        //i.putExtra("id", id);//Funciona por posicion RecyclerView
        i.putExtra("id", (long) pozo.getId_pozo()); //Funciona por id_pozo
        startActivity(i);
    }

}
