package com.examples.pfsoft.mispozosderiego;

import android.content.DialogInterface;
import android.content.Intent;
import android.content.res.Resources;
import android.graphics.Bitmap;
import android.graphics.drawable.BitmapDrawable;
import android.net.Uri;
import android.os.Bundle;
import android.support.v4.app.FragmentActivity;
import android.support.v7.app.AlertDialog;
import android.util.Log;

import com.google.android.gms.maps.CameraUpdateFactory;
import com.google.android.gms.maps.GoogleMap;
import com.google.android.gms.maps.OnMapReadyCallback;
import com.google.android.gms.maps.SupportMapFragment;
import com.google.android.gms.maps.model.BitmapDescriptorFactory;
import com.google.android.gms.maps.model.LatLng;
import com.google.android.gms.maps.model.Marker;
import com.google.android.gms.maps.model.MarkerOptions;
import com.google.firebase.database.DatabaseReference;


/**
 * Created by VRaul on 16/09/2017.
 */

public class ActivityVistaMapaEditar extends FragmentActivity
                                    implements OnMapReadyCallback, GoogleMap.OnMapLongClickListener {
    private GoogleMap mapa;
    private Aplicacion app;
    private long id;private
    InfoPozoRiego pozo;


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_vistamapaeditar);

        app = (Aplicacion) getApplication();

        // Obtenemos el mapa de forma asíncrona (notificará cuando esté listo)
        SupportMapFragment mapFragment = (SupportMapFragment) getSupportFragmentManager().findFragmentById(R.id.mapa2);
        mapFragment.getMapAsync(this);


    }

    @Override
    protected void onResume() {
        super.onResume();
        //Obtener id del Pozo a visualizar...
        Bundle extras = getIntent().getExtras();
        id = extras.getLong("id_mapa", -1);
        if (id!=-1) {
            pozo = app.getPozos().elemento((int) id);
        }
    }


    @Override
    public void onMapReady(GoogleMap googleMap) {
        mapa = googleMap;
        mapa.setMapType(GoogleMap.MAP_TYPE_NORMAL);

        //Ubicación por defecto
        LatLng BUR = new LatLng(39.890295, -0.085656);
       //mapa.addMarker(new MarkerOptions().position(BUR).title("BURRIANA"));
        mapa.moveCamera(CameraUpdateFactory.newLatLngZoom(BUR,15));

        //Extraemos información de localización del pozo
        if (pozo!= null) {
            InfoGeoPunto p = pozo.getPosicion();
            if (p != null && ((p.getLatitud() != 0) || (p.getLongitud() != 0))) {
                //Nos ubicamos en la geolocalizacion del Pozo
                mapa.moveCamera(CameraUpdateFactory.newLatLngZoom(new LatLng(p.getLatitud(), p.getLongitud()), 15));
                //Mostrams marcador en posición
                mapa.addMarker(new MarkerOptions()
                        .position(new LatLng(p.getLatitud(), p.getLongitud()))
                        .title(pozo.getNombre())
                        .snippet(pozo.getDireccion())
                        .icon(BitmapDescriptorFactory.defaultMarker(BitmapDescriptorFactory.HUE_GREEN))
                );
            }
        }

        //Escuchador para detecta pulsación larga sobre el mapa
        mapa.setOnMapLongClickListener(this);
    }

    @Override public void onMapLongClick(final LatLng puntoPulsado) {
        Resources res = getResources();
        new AlertDialog.Builder(this)
                .setTitle(res.getString(R.string.aldialog_06_Titulo))
                .setMessage(res.getString(R.string.aldialog_06_Mensaje))
                .setPositiveButton(res.getString(R.string.txt_confirm), new DialogInterface.OnClickListener() {
                    public void onClick(DialogInterface dialog, int whichButton) {
                        nuevomarcador(puntoPulsado);
                        finish();
                    }})
                .setNegativeButton(res.getString(R.string.txt_cancel), null)
                .show();
    }

    private void nuevomarcador(LatLng puntoPulsado){
        //Limpiar Mapa de Marcadores
        mapa.clear();
        //Nuevo marcador
        mapa.addMarker(new MarkerOptions()
                .position(puntoPulsado)
                .title(pozo.getNombre())
                .snippet(pozo.getDireccion())
                .icon(BitmapDescriptorFactory
                        .defaultMarker(BitmapDescriptorFactory.HUE_GREEN)));

        //Actualizar geolocalización del pozo
        InfoGeoPunto newpos = new InfoGeoPunto(puntoPulsado.longitude, puntoPulsado.latitude);
        if (pozo!= null) {
            pozo.setPosicion(newpos);
            //======== Firebase ====================================
            int id_pozo = (int) id;
            app.getPozos().actualiza(id_pozo, pozo);
            Log.d("[MapaEditar] NuevoPunto", pozo.getNombre() + ". " + pozo.getPosicion().toString());
        }
    }

}
