package com.examples.pfsoft.mispozosderiego;

import android.content.Intent;
import android.content.res.Resources;
import android.graphics.Bitmap;
import android.graphics.drawable.BitmapDrawable;
import android.os.Bundle;
import android.support.v4.app.FragmentActivity;

import com.google.android.gms.maps.CameraUpdateFactory;
import com.google.android.gms.maps.GoogleMap;
import com.google.android.gms.maps.OnMapReadyCallback;
import com.google.android.gms.maps.SupportMapFragment;
import com.google.android.gms.maps.model.BitmapDescriptorFactory;
import com.google.android.gms.maps.model.LatLng;
import com.google.android.gms.maps.model.Marker;
import com.google.android.gms.maps.model.MarkerOptions;


/**
 * Created by VRaul on 16/09/2017.
 */

public class ActivityVistaMapaPozos extends FragmentActivity
                                    implements OnMapReadyCallback, GoogleMap.OnInfoWindowClickListener {
    private GoogleMap mapa;
    private Aplicacion app;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_vistamapapozos);

        app = (Aplicacion) getApplication();

        // Obtenemos el mapa de forma asíncrona (notificará cuando esté listo)
        SupportMapFragment mapFragment = (SupportMapFragment) getSupportFragmentManager().findFragmentById(R.id.mapa);
        mapFragment.getMapAsync(this);


    }


    @Override
    public void onMapReady(GoogleMap googleMap) {
        mapa = googleMap;
        mapa.setMapType(GoogleMap.MAP_TYPE_NORMAL);
        /*
        LatLng UPV = new LatLng(39.481106, -0.340987);
        //Nos ubicamos en la UPV
        mapa.addMarker(new MarkerOptions().position(UPV).title("Marker UPV"));
        mapa.moveCamera(CameraUpdateFactory.newLatLng(UPV));
        */
        if (app.getPozos().tamanyo() > 0) {
            InfoGeoPunto p = app.getPozos().elemento(0).getPosicion();
            mapa.moveCamera(CameraUpdateFactory.newLatLngZoom( new LatLng(p.getLatitud(), p.getLongitud()), 12));
        }
        for (int n=0; n<app.getPozos().tamanyo(); n++) {
            InfoPozoRiego pozo = app.getPozos().elemento(n);
            InfoEstadoPozo estadopozo = app.getEstadopozos().elemento(n);

            InfoGeoPunto p = pozo.getPosicion();
            if (p != null && p.getLatitud() != 0) {
                int idres = estadopozo.getRecursoIconoEstado();
                BitmapDrawable iconoDrawable = (BitmapDrawable) getResources().getDrawable(idres);
                //Bitmap iGrande = iconoDrawable.getBitmap();
                Bitmap icono = iconoDrawable.getBitmap();
                //Bitmap icono = Bitmap.createScaledBitmap(iGrande, iGrande.getWidth() / 7, iGrande.getHeight() / 7, false);
                mapa.addMarker(new MarkerOptions()
                        .position(new LatLng(p.getLatitud(), p.getLongitud()))
                        .title(pozo.getNombre())
                        .snippet(estadopozo.getEnum_estadopozo().getTexto())
                        .icon(BitmapDescriptorFactory.fromBitmap(icono))
                        );
            }
        }
        //Escuchador para detecta pulsación sobre la ventana de información de un marcador del mapa
        mapa.setOnInfoWindowClickListener(this);
    }

    @Override
    public void onInfoWindowClick(Marker marker) {
        for (int id = 0; id < app.getPozos().tamanyo(); id++) {
            if (app.getPozos().elemento(id).getNombre().equals(marker.getTitle())) {
                Intent intent = new Intent(this, ActivityVistaEstadoPozo.class);
                //intent.putExtra("id", (long) id);//Funciona por posición en ArrayList
                //Funciona por id_pozo
                intent.putExtra("id", (long) app.getPozos().elemento(id).getId_pozo());
                startActivity(intent);
                break;
            }
        }
    }

}
