package com.examples.pfsoft.mispozosderiego;

import android.content.Context;
import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.net.Uri;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.Toolbar;
import android.view.View;
import android.widget.CheckBox;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;

import java.io.FileNotFoundException;

/**
 * Created by VRaul on 04/12/2016 [Revision @PFSoft 08/2017]
 * Clase que gestiona la Actividad para Mostrar la información del Pozo sin poder modificarla
 * Se llama desde desde la Actividad VistaEstadoPozo al pulsar Botón Flotante.
 */

public class ActivityVistaPozoSimple extends AppCompatActivity {

    private long id;
    private InfoPozoRiego pozo;


    private ImageView imgLogoDireccion;

    //Para gestionar imagen asociada al del Pozo
    private ImageView imageView;
    private Uri uriFoto;

    private Aplicacion app;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_vistapozosimple);

        app = (Aplicacion) getApplication();

        //Gestíón Toolbar...
        Toolbar toolbar = (Toolbar) findViewById(R.id.toolbar9);
        setSupportActionBar(toolbar);

    }

    @Override
    protected void onResume(){
        super.onResume();
        //Obtener id del Pozo a visualizar...
        Bundle extras = getIntent().getExtras();
        id = extras.getLong("id", -1);
        //Utiliza Firebase...

        //Funciona por posición en el RecyclerView == posicion ArrayList --> Version obsoleta
        //pozo = app.getPozos().elemento((int) id);

        //Funciona por id_pozo --> Nueva versión
        String keyidpozo= app.getStrKeyIdPozo((int)id); //Obtener Clave String a partir del id_pozo
        pozo = app.getPozos().elementoByKey(keyidpozo);

        //Llamada Procedimiento para rellenar VistaPozo con la información del Pozo
        SetVistaPozo();

    }

   void SetVistaPozo (){

        TextView nombre = (TextView) findViewById(R.id.nompozo3);
        nombre.setText(pozo.getNombre());
        TextView telefono = (TextView) findViewById(R.id.telefono3);
        if (pozo.getTelefono().isEmpty()){
            telefono.setVisibility(View.GONE);
        } else {
            telefono.setVisibility(View.VISIBLE);
            telefono.setText(pozo.getTelefono());
        }
        TextView direccion = (TextView) findViewById(R.id.direccion3);
        if (pozo.getDireccion().isEmpty()){
            direccion.setVisibility(View.GONE);
        } else {
            direccion.setVisibility(View.VISIBLE);
            direccion.setText(pozo.getDireccion());
        }
        TextView comentario = (TextView) findViewById(R.id.comentario3);
        if (pozo.getComentario().isEmpty()){
            comentario.setVisibility(View.GONE);
        } else {
            comentario.setVisibility(View.VISIBLE);
            comentario.setText(pozo.getComentario());
        }
        TextView numsectores = (TextView) findViewById(R.id.numsectores3);
        numsectores.setText(Integer.toString(pozo.getNum_sectores()));
        CheckBox esgoteo = (CheckBox)findViewById(R.id.es_goteo3);
        esgoteo.setChecked(pozo.isEs_goteo());
        imageView = (ImageView) findViewById(R.id.foto3);
       //Obtener foto desde URL usando un AsyTask
       new DownloadImageTask(imageView).execute(pozo.getFoto());

    }

}



