package com.examples.pfsoft.mispozosderiego;

import android.os.Bundle;
import android.support.design.widget.FloatingActionButton;
import android.support.design.widget.Snackbar;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.LinearLayoutManager;
import android.support.v7.widget.RecyclerView;
import android.support.v7.widget.Toolbar;
import android.util.Log;
import android.view.View;
import android.widget.TextView;

import com.google.firebase.database.DatabaseReference;

/**
 * Created by VRaul on 11/12/2016.
 */

public class ActivityVistaRiegoHist extends AppCompatActivity {

    private long id;
    private InfoPozoRiego pozo;
    //private InfoEstadoPozo estadopozo;
    private Aplicacion app;
    private RecyclerView recyclerView;
    private RecyclerView.LayoutManager layoutManager;


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_vistariegohist);

        app = (Aplicacion) getApplication();

        //Gestíón Toolbar...
        Toolbar toolbar = (Toolbar) findViewById(R.id.toolbar7);
        setSupportActionBar(toolbar);

    }


    @Override
    protected void onResume(){
        super.onResume();
        //Obtener id del Pozo a visualizar su Historico de Riegos...
        Bundle extras = getIntent().getExtras();
        id = extras.getLong("id", -1);
        //Para Firebase --->

        //Funciona por posición en el RecyclerView == posicion ArrayList --> Version obsoleta
        //pozo = app.getPozos().elemento((int) id);

        //Funciona por id_pozo --> Nueva versión
        String keyidpozo= app.getStrKeyIdPozo((int)id); //Obtener Clave String a partir del id_pozo
        pozo = app.getPozos().elementoByKey(keyidpozo);


        //Obtener Nombre pozo y asignarlo a la Vista
        TextView nombre = (TextView) findViewById(R.id.nompozo4);
        nombre.setText(pozo.getNombre());

        //Obtener key idpozo para tener referecia al nodo de riegos que nos interesa
        String keypozo = app.getStrKeyIdPozo(pozo.getId_pozo());
        DatabaseReference nodopozo = app.getRiegosReference().child(keypozo);

        //Crear Alamacen y Adaptador (Historico Riegos) para los datos obtenidos desde firebase a  partir de la referencia
        Log.d("====> Historico: " , "ON Escuchador");
       app.setRiegos(new AlmacenRiegoHistFBase(this, nodopozo));
        app.getRiegos().activaEscuchadorRiegoHist();
       app.setAdaptadorRiegos(new AdaptadorRiegoHist(this, app.getRiegos()));



        //Codigo para Recycler View
        recyclerView = (RecyclerView) findViewById(R.id.recycler_view3);
        recyclerView.setAdapter(app.getAdaptadorRiegos());
        layoutManager = new LinearLayoutManager(this);
        recyclerView.setLayoutManager(layoutManager);

        //Escuchador de eventos por selección de un elemento del Recycler View
        /*
        app.getAdaptadorpozos().setOnItemClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Intent i = new Intent(ActivitySeleccionPozo.this, ActivityVistaPozo.class);
                i.putExtra("id", (long) recyclerView.getChildAdapterPosition(v));
                //i.putExtra("seleccion", true); //Indica que viene desde Vista Seleccion Pozo
                startActivity(i);
            }
        });  */



    }


    @Override public void onPause() {
        Log.d("====> Historico: " , "OFF Escuchador");
        app.getRiegos().desactivaEscuchadorRiegoHist();

        super.onPause();

    }

    /*
    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_vistaestadopozo, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.

        switch (item.getItemId()) {
            case R.id.accion_riegos:

                return true;
            case R.id.accion_alarmas:

                return true;

            default:
                return super.onOptionsItemSelected(item);
        }
    }
    */

}
