package com.examples.pfsoft.mispozosderiego;

import android.content.Context;
import android.content.res.Resources;
import android.support.v7.widget.RecyclerView;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.TextView;

import java.text.DecimalFormat;

/**
 * Created by VRaul on 15/09/2017.
 */

public class AdaptadorAlarmaHist extends RecyclerView.Adapter<AdaptadorAlarmaHist.ViewHolder> {

    protected AlmacenAlarmaHist alarmas; // Lista de alarmas a mostrar

    protected LayoutInflater inflador; // Crea Layouts a partir del XML
    protected Context contexto; // Lo necesitamos para el inflador
    private Aplicacion app;
    //protected View.OnClickListener onClickListener;

    //Constructor
    public AdaptadorAlarmaHist(Context contexto, AlmacenAlarmaHist alarmas) {
        this.contexto = contexto;
        this.app = (Aplicacion) contexto.getApplicationContext();
        this.alarmas = alarmas;
        inflador = (LayoutInflater) contexto
                .getSystemService(Context.LAYOUT_INFLATER_SERVICE);
    }

    //Setter
    /*
    public void setOnItemClickListener(View.OnClickListener onClickListener) {
        this.onClickListener = onClickListener;
    }*/


    //Creamos nuestro ViewHolder, con los tipos de elementos a modificar
    public static class ViewHolder extends RecyclerView.ViewHolder {
        public TextView idalarma, fechainicio, horainicio, duracion;
        public TextView idriego, tipoalarma;
        public ImageView icono;

        public ViewHolder(View itemView) {
            super(itemView);
            idalarma = (TextView) itemView.findViewById(R.id.id_alarma);
            fechainicio = (TextView) itemView.findViewById(R.id.fechainicio3);
            horainicio = (TextView) itemView.findViewById(R.id.horainicio3);
            duracion = (TextView) itemView.findViewById(R.id.duracion3);
            idriego = (TextView) itemView.findViewById(R.id.id_riego3);
            tipoalarma = (TextView) itemView.findViewById(R.id.tipo_alarma2);

            icono = (ImageView) itemView.findViewById(R.id.logo_estado4);
        }
    }
    // Creamos el ViewHolder con la vista de un elemento sin personalizar
    @Override
    public AdaptadorAlarmaHist.ViewHolder onCreateViewHolder(ViewGroup parent, int viewType) {
// Inflamos la vista desde el xml
        View v = inflador.inflate(R.layout.elemento_listahistalarma, parent, false);
        //v.setOnClickListener(onClickListener); //Asignamos escuchador a cada una de las vistas creadas
        return new AdaptadorAlarmaHist.ViewHolder(v);
    }
    // Usando como base el ViewHolder y lo personalizamos
    @Override
    public void onBindViewHolder(AdaptadorAlarmaHist.ViewHolder holder, int posicion) {
        InfoAlarmaHist alarmahist =  alarmas.elemento(posicion);
        personalizaVista(holder, alarmahist);
    }

    public void personalizaVista(AdaptadorAlarmaHist.ViewHolder holder, InfoAlarmaHist alarmahist) {

        int idres;
        Resources res = contexto.getResources();

        holder.idalarma.setText(app.getStrKeyIdAlarma(alarmahist.getId_alarma()));
        holder.fechainicio.setText(alarmahist.getFecha_inicio());
        holder.horainicio.setText(alarmahist.getHora_inicio());
        holder.duracion.setText(alarmahist.conversionDuracion());
        if (alarmahist.getId_riego()>0) {
            holder.idriego.setBackgroundColor(res.getColor(R.color.colorLimaCab));
            holder.idriego.setVisibility(View.VISIBLE);
            holder.idriego.setText(app.getStrKeyIdRiego(alarmahist.getId_riego()));
        } else{
            holder.idriego.setVisibility(View.INVISIBLE);
            holder.idriego.setBackgroundColor(res.getColor(R.color.colorPrimaryDark));
        }
        holder.tipoalarma.setText(alarmahist.getEnum_infoalarma().getTexto());
        idres = alarmahist.getRecursoIconoEstado();
        holder.icono.setImageResource(idres);
        holder.icono.setScaleType(ImageView.ScaleType.FIT_END);
    }
    // Indicamos el número de elementos de la lista
    @Override public int getItemCount() {
        return alarmas.tamanyo();
    }

}
