package com.examples.pfsoft.mispozosderiego;

import android.content.Context;

import android.support.v7.widget.RecyclerView;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.TextView;

import java.text.DateFormat;
import java.util.Date;

/**
 * Created by VRaul on 06/12/2016.
 */

public class AdaptadorEstadoPozos extends RecyclerView.Adapter<AdaptadorEstadoPozos.ViewHolder> {

    protected AlmacenInfoEstado estadopozos; // Lista de estados de pozos a mostrar
    protected AlmacenPozos pozos; // Lista de pozos a mostrar

    protected LayoutInflater inflador; // Crea Layouts a partir del XML
    protected Context contexto; // Lo necesitamos para el inflador
    protected View.OnClickListener onClickListener;

    //Constructor
    public AdaptadorEstadoPozos(Context contexto, AlmacenInfoEstado estadopozos, AlmacenPozos pozos) {
        this.contexto = contexto;
        this.estadopozos = estadopozos;
        this.pozos = pozos;
        inflador = (LayoutInflater) contexto
                .getSystemService(Context.LAYOUT_INFLATER_SERVICE);
    }

    //Setter
    public void setOnItemClickListener(View.OnClickListener onClickListener) {
        this.onClickListener = onClickListener;
    }


    //Creamos nuestro ViewHolder, con los tipos de elementos a modificar
    public static class ViewHolder extends RecyclerView.ViewHolder {
        public TextView nombre, infoestado, fechasms ;
        public ImageView foto;

        public ViewHolder(View itemView) {
            super(itemView);
            nombre = (TextView) itemView.findViewById(R.id.selNombre2);
            infoestado = (TextView) itemView.findViewById(R.id.selTipoEstado);
            fechasms = (TextView) itemView.findViewById(R.id.selFechaSMS);
            foto = (ImageView) itemView.findViewById(R.id.logo_estado);
        }
    }
    // Creamos el ViewHolder con la vista de un elemento sin personalizar
    @Override
    public ViewHolder onCreateViewHolder(ViewGroup parent, int viewType) {
// Inflamos la vista desde el xml
        View v = inflador.inflate(R.layout.elemento_listaestados, parent, false);
        v.setOnClickListener(onClickListener); //Asignamos escucharo a cada una de las vistas creadas
        return new ViewHolder(v);
    }
    // Usando como base el ViewHolder y lo personalizamos
    @Override
    public void onBindViewHolder(ViewHolder holder, int posicion) {
        InfoEstadoPozo estadopozo =  estadopozos.elemento(posicion);
        InfoPozoRiego pozo = pozos.elemento(posicion);
        personalizaVista(holder, estadopozo, pozo);
    }

    public void personalizaVista(ViewHolder holder, InfoEstadoPozo estadopozo, InfoPozoRiego pozo) {
        int idres = estadopozo.getRecursoIconoEstado();;

        holder.nombre.setText(pozo.getNombre());
        holder.infoestado.setText(estadopozo.getEnum_estadopozo().getTexto());
        holder.fechasms.setText(DateFormat.getDateTimeInstance().format(new Date(estadopozo.getFechahora_sms())));
        holder.foto.setImageResource(idres);
        holder.foto.setScaleType(ImageView.ScaleType.FIT_END);

        }
    // Indicamos el número de elementos de la lista
        @Override public int getItemCount() {
            return estadopozos.tamanyo();
        }


}
