package com.examples.pfsoft.mispozosderiego;

import android.content.Context;
import android.support.v7.widget.RecyclerView;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.TextView;

/**
 * Created by VRaul on 06/12/2016.
 */

public class AdaptadorPozos extends RecyclerView.Adapter<AdaptadorPozos.ViewHolder> {

    protected AlmacenPozos pozos; // Lista de pozos a mostrar
    protected LayoutInflater inflador; // Crea Layouts a partir del XML
    protected Context contexto; // Lo necesitamos para el inflador
    protected View.OnClickListener onClickListener;

    //Constructor
    public AdaptadorPozos(Context contexto, AlmacenPozos pozos) {
        this.contexto = contexto;
        this.pozos = pozos;
        inflador = (LayoutInflater) contexto
                .getSystemService(Context.LAYOUT_INFLATER_SERVICE);
    }

    //Setter
    public void setOnItemClickListener(View.OnClickListener onClickListener) {
        this.onClickListener = onClickListener;
    }


    //Creamos nuestro ViewHolder, con los tipos de elementos a modificar
    public static class ViewHolder extends RecyclerView.ViewHolder {
        public TextView nombre, direccion;
        public ImageView foto;

        public ViewHolder(View itemView) {
            super(itemView);
            nombre = (TextView) itemView.findViewById(R.id.selNombre);
            direccion = (TextView) itemView.findViewById(R.id.selDireccion);
            foto = (ImageView) itemView.findViewById(R.id.logo_esgoteo);
        }
    }
    // Creamos el ViewHolder con la vista de un elemento sin personalizar
    @Override
    public ViewHolder onCreateViewHolder(ViewGroup parent, int viewType) {
// Inflamos la vista desde el xml
        View v = inflador.inflate(R.layout.elemento_lista, parent, false);
        v.setOnClickListener(onClickListener); //Asignamos escucharo a cada una de las vistas creadas
        return new ViewHolder(v);
    }
    // Usando como base el ViewHolder y lo personalizamos
    @Override
    public void onBindViewHolder(ViewHolder holder, int posicion) {
        InfoPozoRiego pozo = pozos.elemento(posicion);
        personalizaVista(holder, pozo);
    }

    public void personalizaVista(ViewHolder holder, InfoPozoRiego pozo) {
        int id;

        holder.nombre.setText(pozo.getNombre());
        holder.direccion.setText(pozo.getDireccion());
        if (pozo.isEs_goteo()) {
            id = R.mipmap.ic_wet;
        } else {
            id = R.mipmap.ic_waterelement;
        }
        holder.foto.setImageResource(id);
        holder.foto.setScaleType(ImageView.ScaleType.FIT_END);

        }
// Indicamos el número de elementos de la lista
        @Override public int getItemCount() {
            return pozos.tamanyo();
        }


}
