package com.examples.pfsoft.mispozosderiego;

import android.content.Context;
import android.content.res.Resources;
import android.support.v7.widget.RecyclerView;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.TextView;

import java.text.DecimalFormat;

/**
 * Created by VRaul on 15/09/2017.
 */

public class AdaptadorRiegoHist extends RecyclerView.Adapter<AdaptadorRiegoHist.ViewHolder> {

    protected AlmacenInfoEstado riegos; // Lista de riegos a mostrar

    protected LayoutInflater inflador; // Crea Layouts a partir del XML
    protected Context contexto; // Lo necesitamos para el inflador
    private Aplicacion app;
    //protected View.OnClickListener onClickListener;

    //Constructor
    public AdaptadorRiegoHist(Context contexto, AlmacenInfoEstado riegos) {
        this.contexto = contexto;
        this.app = (Aplicacion) contexto.getApplicationContext();
        this.riegos = riegos;
        inflador = (LayoutInflater) contexto
                .getSystemService(Context.LAYOUT_INFLATER_SERVICE);
    }

    //Setter
    /*
    public void setOnItemClickListener(View.OnClickListener onClickListener) {
        this.onClickListener = onClickListener;
    }*/


    //Creamos nuestro ViewHolder, con los tipos de elementos a modificar
    public static class ViewHolder extends RecyclerView.ViewHolder {
        public TextView idriego, fechainicio, horainicio, duracion;
        public TextView programa, sector1, sector2, sector3, sector4, sector5, sector6;
        public TextView caudal, potencia;
        public ImageView icono;

        public ViewHolder(View itemView) {
            super(itemView);
            idriego = (TextView) itemView.findViewById(R.id.id_riego2);
            fechainicio = (TextView) itemView.findViewById(R.id.fechainicio2);
            horainicio = (TextView) itemView.findViewById(R.id.horainicio2);
            duracion = (TextView) itemView.findViewById(R.id.duracion2);
            programa = (TextView) itemView.findViewById(R.id.programa2);
            sector1 = (TextView) itemView.findViewById(R.id.sector2_1);
            sector2 = (TextView) itemView.findViewById(R.id.sector2_2);
            sector3 = (TextView) itemView.findViewById(R.id.sector2_3);
            sector4 = (TextView) itemView.findViewById(R.id.sector2_4);
            sector5 = (TextView) itemView.findViewById(R.id.sector2_5);
            sector6 = (TextView) itemView.findViewById(R.id.sector2_6);
            caudal = (TextView) itemView.findViewById(R.id.caudal2);
            potencia = (TextView) itemView.findViewById(R.id.potencia2);
            icono = (ImageView) itemView.findViewById(R.id.logo_estado3);
        }
    }
    // Creamos el ViewHolder con la vista de un elemento sin personalizar
    @Override
    public AdaptadorRiegoHist.ViewHolder onCreateViewHolder(ViewGroup parent, int viewType) {
// Inflamos la vista desde el xml
        View v = inflador.inflate(R.layout.elemento_listahistriego, parent, false);
        //v.setOnClickListener(onClickListener); //Asignamos escuchador a cada una de las vistas creadas
        return new AdaptadorRiegoHist.ViewHolder(v);
    }
    // Usando como base el ViewHolder y lo personalizamos
    @Override
    public void onBindViewHolder(AdaptadorRiegoHist.ViewHolder holder, int posicion) {
        InfoEstadoPozo estadopozo =  riegos.elemento(posicion);
        personalizaVista(holder, estadopozo);
    }

    public void personalizaVista(AdaptadorRiegoHist.ViewHolder holder, InfoEstadoPozo estadopozo) {

        int idres;
        Resources res = contexto.getResources();

        holder.idriego.setText(app.getStrKeyIdRiego(estadopozo.getId_riego()));
        holder.fechainicio.setText(estadopozo.getFecha_inicio());
        holder.horainicio.setText(estadopozo.getHora_inicio());
        holder.duracion.setText(estadopozo.conversionDuracion());
        holder.programa.setText(Integer.toString(estadopozo.getPrograma()));
        if (estadopozo.esSectorActivo(1)){
            holder.sector1.setTextColor(res.getColor(R.color.colorVerdeOn));
        } else{
            holder.sector1.setTextColor(res.getColor(R.color.colorGrisOff));
        }
        if (estadopozo.esSectorActivo(2)){
            holder.sector2.setTextColor(res.getColor(R.color.colorVerdeOn));
        } else{
            holder.sector2.setTextColor(res.getColor(R.color.colorGrisOff));
        }
        if (estadopozo.esSectorActivo(3)){
            holder.sector3.setTextColor(res.getColor(R.color.colorVerdeOn));
        } else{
            holder.sector3.setTextColor(res.getColor(R.color.colorGrisOff));
        }
        if (estadopozo.esSectorActivo(4)){
            holder.sector4.setTextColor(res.getColor(R.color.colorVerdeOn));
        } else{
            holder.sector4.setTextColor(res.getColor(R.color.colorGrisOff));
        }
        if (estadopozo.esSectorActivo(5)){
            holder.sector5.setTextColor(res.getColor(R.color.colorVerdeOn));
        } else{
            holder.sector5.setTextColor(res.getColor(R.color.colorGrisOff));
        }
        if (estadopozo.esSectorActivo(6)){
            holder.sector6.setTextColor(res.getColor(R.color.colorVerdeOn));
        } else{
            holder.sector6.setTextColor(res.getColor(R.color.colorGrisOff));
        }
        DecimalFormat fmt = new DecimalFormat("#.0");
        holder.caudal.setText(fmt.format(estadopozo.getCaudal()));
        holder.potencia.setText(fmt.format(estadopozo.getPot_consumida()));


        if ((estadopozo.getEnum_estadopozo()== ETipoEstado.ALM_RIEGO_PROG) || (estadopozo.getEnum_estadopozo()== ETipoEstado.ALM_RIEGO_MAN)){
            idres = R.mipmap.ic_regadera_red;
        } else {
            idres = estadopozo.getRecursoIconoEstado();
        }
        //idres = estadopozo.getRecursoIconoEstado();
        holder.icono.setImageResource(idres);
        holder.icono.setScaleType(ImageView.ScaleType.FIT_END);

    }
    // Indicamos el número de elementos de la lista
    @Override public int getItemCount() {
        return riegos.tamanyo();
    }


}