package com.examples.pfsoft.mispozosderiego;

import android.content.Context;
import android.util.Log;
import com.google.firebase.database.ChildEventListener;
import com.google.firebase.database.DataSnapshot;
import com.google.firebase.database.DatabaseError;
import com.google.firebase.database.DatabaseReference;

import java.text.DecimalFormat;
import java.util.ArrayList;

/**
 * Created by VRaul on 15/09/2017.
 */

public class AlmacenRiegoHistFBase implements AlmacenInfoEstado, ChildEventListener  {

    Context contexto;
    private Aplicacion app;
    private DatabaseReference nodopozo;

    //Usamos SDK Firebase para tener más control - Necesitamos una estructura que almacene los datos.
    private ArrayList<String> keys;
    private ArrayList<DataSnapshot> items;

    private InfoEstadoPozo newEstadoPozo; //Auxiliar nuevo InfoRiego Pozo

    public AlmacenRiegoHistFBase(Context contexto, DatabaseReference nodopozo) {
        this.contexto = contexto;
        this.app = (Aplicacion) contexto.getApplicationContext();
        this.nodopozo = nodopozo;

        keys = new ArrayList<String>();
        items = new ArrayList<DataSnapshot>();

        //this.nodopozo.addChildEventListener(this); //Escuchador asociado a cambios en los estados de los pozos...
    }

    public InfoEstadoPozo getNewEstadoPozo() {
        return newEstadoPozo;
    }

    public void setNewEstadoPozo(InfoEstadoPozo newEstadoPozo) {
        this.newEstadoPozo = newEstadoPozo;
    }

    //Referencia de cada nodo de la lista
    public DatabaseReference getRef(int id) {
        return items.get(id).getRef();
    }

    //Obtener Clave asociada a un Id
    public String getItemKey(int id) {
        return keys.get(id);
    }

    @Override
    public InfoEstadoPozo elemento(int id){
        InfoEstadoPozo estadopozo = items.get(id).getValue(InfoEstadoPozo.class);
        return estadopozo;
    }

    //Obtener elemento a partir de la Clave asociada ID_POZO
    public InfoEstadoPozo elementoByKey(String key){
        int index = keys.indexOf(key); //Obtiene indice lista donde aparece la Clave
        if (index != -1) {
            InfoEstadoPozo estadopozo = items.get(index).getValue(InfoEstadoPozo.class);
            return estadopozo;
        } else {
            return null;
        }
    }

    @Override
    public void anyade(InfoEstadoPozo estadopozo) {

    }

    @Override
    public int nuevo(int id) {

        return id;
    }

    @Override
    public void borrar(int id) {

    }

    @Override
    public int tamanyo() {
        return items.size();
    }

    @Override
    public void actualiza(int id, InfoEstadoPozo estadopozo) {

    }


    @Override public void onChildAdded(DataSnapshot dataSnapshot, String s) {

        Log.d("OnChildAdded Riegos ", Integer.toString(dataSnapshot.getValue(InfoEstadoPozo.class).getId_pozo()));
        items.add(dataSnapshot);
        Log.d("Key - Riegos ", dataSnapshot.getKey());
        keys.add(dataSnapshot.getKey());
        app.getAdaptadorRiegos().notifyItemInserted(app.getAdaptadorRiegos().getItemCount()-1);
    }
    @Override public void onChildChanged(DataSnapshot dataSnapshot, String s) {
        String key = dataSnapshot.getKey();
        int index = keys.indexOf(key);
        if (index!=-1) {
            items.set(index, dataSnapshot);
            app.getAdaptadorRiegos().notifyItemChanged(index, dataSnapshot.getValue(InfoEstadoPozo.class));
        }
    }
    @Override public void onChildRemoved(DataSnapshot dataSnapshot) {
        String key = dataSnapshot.getKey();
        int index = keys.indexOf(key);
        if (index!=-1) {
            keys.remove(index);
            items.remove(index);
            app.getAdaptadorRiegos().notifyItemRemoved(index);
        }
    }
    @Override public void onChildMoved(DataSnapshot dataSnapshot, String s) {}
    @Override public void onCancelled(DatabaseError databaseError) {}


    public void activaEscuchadorRiegoHist(){
        keys = new ArrayList<String>();
        items = new ArrayList<DataSnapshot>();
        nodopozo.addChildEventListener(this);
    }

    public void desactivaEscuchadorRiegoHist(){
        nodopozo.removeEventListener(this);
    }


}
