package com.examples.pfsoft.mispozosderiego;

import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.net.Uri;
import android.os.AsyncTask;
import android.widget.ImageView;

import java.io.InputStream;

/**
 * Created by VRaul on 17/09/2017 -  - [Revision @PFSoft 08/2017]
 *
 * Clase que gestiona la descarga de una imagen desde una URL utilizando un AsynTask
 *
 */

public class DownloadImageTask extends AsyncTask<String, Void, Bitmap> {

    ImageView bmImage;

    public DownloadImageTask(ImageView bmImage) {
        this.bmImage = bmImage;
    }

    protected Bitmap doInBackground(String... urls) {
        String urldisplay = urls[0];
        Bitmap mImagen = null;
        try {
            InputStream in = new java.net.URL(urldisplay).openStream();
            mImagen = BitmapFactory.decodeStream(in);

            /*
             // Para evitar problemas de memoria con fotos grandes ---> Probar si funciona....
            InputStream in = new java.net.URL(urldisplay).openStream();
            final BitmapFactory.Options options = new BitmapFactory.Options();
            options.inJustDecodeBounds = true;
            BitmapFactory.decodeStream(in, null, options);
            options.inSampleSize = (int) Math.max(
                    Math.ceil(options.outWidth / 2048),
                    Math.ceil(options.outHeight / 2048));
            options.inJustDecodeBounds = false;
            mImagen =  BitmapFactory.decodeStream(in, null, options);
            */

            }

        catch (Exception e) {
            e.printStackTrace();
        }
        return mImagen;
    }

    protected void onPostExecute(Bitmap result) {
        bmImage.setImageBitmap(result);
    }
}
