package com.examples.pfsoft.mispozosderiego;

/**
 * Created by VRaul on 05/12/2016.
 */

//Enumerado que codifica la Información asociada a los posibles Estados del Pozo
public enum ETipoEstado {
    NINGUNO (0, "NINGUNO", 0),
    RIEGO (10, "EN RIEGO",1),
    RIEGO_PROG (11, "EN RIEGO PROGRAMADO",2),
    RIEGO_MAN (12, "EN RIEGO MANUAL",3),
    PARADO (20, "PARADO", 0),
    FIN_RIEGO_PROG (21, "FIN RIEGO PROGRAMADO",4),
    FIN_RIEGO_MAN (22, "FIN RIEGO MANUAL",5),
    ALARMA (30, "EN ALARMA",6),
    ALM_RIEGO_PROG (31, "ALARMA EN RIEGO PROGRAMADO",7),
    ALM_RIEGO_MAN (32, "ALARMA EN RIEGO MANUAL",8),
    FIN_ALARMA (40, "FIN ALARMA",9),
    FINALM_RIEGO_PROG (41, "FIN ALARMA RIEGO PROGRAMADO",10),
    FINALM_RIEGO_MAN (42, "FIN ALARMA RIEGO MANUAL",10);


    private final int id_estado; //Valor numérico asociado al Estado
    private final String texto; //Texto que se muestra como descripción del Estado
    private final int recurso; //Valor numérico que nos asocia un recurso gráfico (icono) asociado al Estado

    ETipoEstado(int id_estado, String texto, int recurso) {
        this.id_estado = id_estado;
        this.texto = texto;
        this.recurso = recurso;
    }

    public int getId_estado() {
        return id_estado;
    }

    public String getTexto() {
        return texto;
    }

    public int getRecurso() {
        return recurso;
    }
}
