package com.examples.pfsoft.mispozosderiego;

/**
 * Created by VRaul on 05/12/2016 - @PFSoft 2016
 * Clase que gestiona la información asociada al Estado Actual del Pozo
 * Para manejar la información en la Tabla asociada en BD u otra estructura de almacenaje que se use
 */

public class InfoEstadoPozo extends InfoBasicaRiego{


    private long fechahora_sms;  //Fecha y Hora Recepcion SMS Actualización InfoEstadoRiego en milisegundos  [Formato visualización:dd/mm/aaaa - hh:mm]
    //private ETipoEstado enum_estado_pozo; //Enumerado que codifica la Información asociada a los posibles Estados del Pozo
    //private ETipoAlarma enum_info_alarma; //Enumerado que codifica la Información de la Alarma asociada al Estado de Alarma del Pozo
    private int estado_pozo; //Ordinal asociada a los posibles Estados del Pozo
    private int info_alarma; //Ordinal asociada al Estado de Alarma del Pozo

    //Constructores
    //Construcor Vacio para el POJO
    public InfoEstadoPozo(){
        super();
        fechahora_sms = System.currentTimeMillis();
        estado_pozo = ETipoEstado.NINGUNO.ordinal();
        info_alarma = ETipoAlarma.NINGUNO.ordinal();
    }

    public InfoEstadoPozo(int id_pozo){
        super(id_pozo);
        fechahora_sms = System.currentTimeMillis();
        estado_pozo = ETipoEstado.NINGUNO.ordinal();
        info_alarma = ETipoAlarma.NINGUNO.ordinal();
    }

    public InfoEstadoPozo(int id_pozo, long fecha_hora, String fecha_inicio, String hora_inicio,
                          long fechahora_sms, int estado_pozo, int info_alarma,
                          int programa, int sectores, int duracion) {
        super(id_pozo,fecha_hora, fecha_inicio, hora_inicio);
        this.fechahora_sms = fechahora_sms;
        this.estado_pozo = estado_pozo;
        this.info_alarma = info_alarma;
        this.setPrograma(programa);
        this.setSectores(sectores);
        this.setDuracion(duracion);
    }

    //Getters & Setters - Necesarios para el POJO

    public long getFechahora_sms() {
        return fechahora_sms;
    }

    public void setFechahora_sms(long fechahora_sms) {
        this.fechahora_sms = fechahora_sms;
    }


    public int getEstado_pozo() {
        return estado_pozo;
    }

    public void setEstado_pozo(int estado_pozo) {
        this.estado_pozo = estado_pozo;
    }

    public int getInfo_alarma() {
        return info_alarma;
    }

    public void setInfo_alarma(int info_alarma) {
        this.info_alarma = info_alarma;
    }

    @Override
    public String toString() {
        return super.toString() +
                "{ fechahora_sms=" + fechahora_sms +
                ", estado_pozo=" + getEnum_estadopozo().getTexto() +
                ", tipo_alarma=" + getEnum_infoalarma().getTexto() +
                '}';
    }


    public ETipoEstado getEnum_estadopozo() {
        return ETipoEstado.values()[estado_pozo];
    }

    public ETipoAlarma getEnum_infoalarma() {
        return ETipoAlarma.values()[info_alarma];
    }

    //Obtener Recurso mipmap asociado al Estado del pozo
    public int getRecursoIconoEstado (){
        int id;
        int idestado = getEnum_estadopozo().getRecurso();

        //Log.d("===> estado ",Integer.toString(idestado));
        switch(idestado) {
            case 0:
                id = R.mipmap.ic_waterdrop_grey;
                break;
            case 1:
                id = R.mipmap.ic_waterdrop_green;
                break;
            case 2:
                id = R.mipmap.ic_waterdrop_blue;
                break;
            case 3:
                id = R.mipmap.ic_waterdrop_orange;
                break;
            case 4:
                id = R.mipmap.ic_regadera_blue;
                break;
            case 5:
                id = R.mipmap.ic_regadera_orange;
                break;
            case 6:
                id = R.mipmap.ic_alarm_red;
                break;
            case 7:
                id = R.mipmap.ic_alarm_blue;
                break;
            case 8:
                id = R.mipmap.ic_alarm_orange;
                break;
            case 9:
                id = R.mipmap.ic_alarm_grey;
                break;
            case 10:
                id = R.mipmap.ic_alarm_grey;
                break;
            default:
                id = R.mipmap.ic_waterdrop_grey;
                break;

        }
        //Log.d("===> id icono ",Integer.toString(id));
        return id;
    }



}
