package com.examples.pfsoft.mispozosderiego;

/**
 * Created by VRaul on 30/11/2016 - @PFSoft 2016
 * Clase que gestiona la información del Pozo para su Gestiónb en la BD (Tabla PozosRiego)
 */

//Firebase: Necesito un POJO para conversion de datos (DataSnapshot) entre JSON y nuestra clase

public class InfoPozoRiego {

    private static final int MAX_SECTORES = 6; //Máximo número de sectores

    //Atributos Principales
    private int id_pozo; //Autonumérico - Clave Principal Tabla PozosRiego
    private int id_propietario; //Clave relacional con Tabla PropietariosPozos
    private String nombre;
    private String direccion;
    private InfoGeoPunto posicion; //Geolocalizacion Pozo (longitud y latitud)
    private String telefono;   //Numero Teléfono tarjeta SIM del módem
    private boolean es_goteo; //Riego por Goteo (TRUE) - Riego por inundación (FALSE)
    private int num_sectores; //Numero sectores de Riego
    private String comentario; //Información adicional
    private String foto; //Foto del Pozo

    //Constructores

    //Constructor vacío para el POJO
    public InfoPozoRiego() {
        id_pozo = 0;
        id_propietario = 0;
        posicion = new InfoGeoPunto(0,0);
    }

    public InfoPozoRiego(int id_pozo){
        this.id_pozo = id_pozo;
        id_propietario = 0;
        posicion = new InfoGeoPunto(0,0);
    }


    public InfoPozoRiego(int id_pozo, int id_propietario, String nombre, String direccion,
                         double longitud, double latitud, String telefono, boolean es_goteo,
                         int num_sectores, String comentario) {
        this.id_pozo = id_pozo;
        this.id_propietario = id_propietario;
        this.nombre = nombre;
        this.direccion = direccion;
        this.posicion = new InfoGeoPunto(longitud, latitud);
        this.telefono = telefono;
        this.es_goteo = es_goteo;
        this.num_sectores = num_sectores;
        this.comentario = comentario;
    }


    //Getters & Setters - Necesarios para el POJO
    public int getMAX_SECTORES() {
        return MAX_SECTORES;
    }

    public int getId_pozo() {
        return id_pozo;
    }

    public void setId_pozo(int id_pozo) {
        this.id_pozo = id_pozo;
    }

    public int getId_propietario() {
        return id_propietario;
    }

    public void setId_propietario(int id_propietario) {
        this.id_propietario = id_propietario;
    }

    public String getNombre() {
        return nombre;
    }

    public void setNombre(String nombre) {
        this.nombre = nombre;
    }

    public String getDireccion() {
        return direccion;
    }

    public void setDireccion(String direccion) {
        this.direccion = direccion;
    }

    public InfoGeoPunto getPosicion() {
        return posicion;
    }

    public void setPosicion(InfoGeoPunto posicion) {
        this.posicion = posicion;
    }

    public String getTelefono() {
        return telefono;
    }

    public void setTelefono(String telefono) {
        this.telefono = telefono;
    }

    public boolean isEs_goteo() {
        return es_goteo;
    }

    public void setEs_goteo(boolean es_goteo) {
        this.es_goteo = es_goteo;
    }

    public int getNum_sectores() {
        return num_sectores;
    }

    public void setNum_sectores(int num_sectores) {
        this.num_sectores = num_sectores;
    }

    public String getComentario() {
        return comentario;
    }

    public void setComentario(String comentario) {
        this.comentario = comentario;
    }

    public String getFoto() {
        return foto;
    }

    public void setFoto(String foto) {
        this.foto = foto;
    }

    //Sobreescribe Método toString
    @Override
    public String toString() {
        return "InfoPozoRiego{" +
                "id_pozo=" + id_pozo +
                ", id_propietario=" + id_propietario +
                ", nombre='" + nombre + '\'' +
                ", direccion='" + direccion + '\'' +
                ", posicion=" + posicion +
                ", telefono='" + telefono + '\'' +
                ", es_goteo=" + es_goteo +
                ", num_sectores=" + num_sectores +
                ", comentario='" + comentario + '\'' +
                ", foto='" + foto + '\'' +
                '}';
    }
}
