package com.examples.pfsoft.mispozosderiego;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.telephony.SmsMessage;
import android.util.Log;
import android.widget.Toast;

/**
 * Created by VRaul on 14/12/2016 -  [Revision @PFSoft 09/2017]
 * Clase Gestiona la Recepción del SMS --> Ejecutar Servicio extrae informacion de estado
 */

public class ReceptorSMS extends BroadcastReceiver {
    public static final String ACTION_RECIBIR_SMS ="android.provider.Telephony.SMS_RECEIVED";

    @Override
    public void onReceive(Context context, Intent intent) {

        Log.d("ReceptorAnuncios SMS", "intent=" + intent);
        //Toast.makeText(context, "Recepcion SMS", Toast.LENGTH_LONG).show();

        Bundle bundle = intent.getExtras();
        String smsnumber = "";
        String smsbodytext = "";

        if (bundle != null) {
            Object[] pdusObj = (Object[]) bundle.get("pdus");
            SmsMessage[] messages = new SmsMessage[pdusObj.length];

            // getting SMS information from Pdu.
            for (int i = 0; i < pdusObj.length; i++) {
                messages[i] = SmsMessage.createFromPdu((byte[]) pdusObj[i]);
            }

            for (SmsMessage currentMessage : messages) {
                smsnumber = currentMessage.getDisplayOriginatingAddress();   //Obtiene el número de teléfono
                smsbodytext= currentMessage.getDisplayMessageBody();    //Obtiene el texto del mensaje

            }
        }

        Log.d("[ReceptorAnuncios SMS]", "SMS Recibido- Telefono: " + smsnumber + " - Mensaje: " + smsbodytext);
        //Solo Pruebas - Elimiar de la versión Final
        //Toast.makeText(context, "[Pruebas] SMS Recibido - Telefono: " + smsnumber + " - Mensaje: " + smsbodytext, Toast.LENGTH_LONG).show();

        //Arrancar servicio para extraer información del SMS
        //Nota: En el futuro se implementará en un hilo secundario con un Intent Service...
        Intent i = new Intent(context, ServicioProcesarSMS.class);
        i.putExtra("smsnumber",smsnumber );
        i.putExtra("smsbodytext",smsbodytext );
        context.startService(i);
    }
}

